// Fonctions de Vertyos (Bob64)
// Tires de Vertel, librairie pour les prorgammeurs
// TiBasic !

SYM_ENTRY *vat_open(const char *ssc_var);
char *vat_name(const char *ssc_var);
SYM_ENTRY *vat_make(const char *ssc_var,unsigned short sui_siz);
char *vat_heap(SYM_ENTRY *sxs_var);

unsigned char tuc_nam[19];

 //----- Optention d'un pointeur char sur l'handle ------//
char *vat_heap(SYM_ENTRY *sxs_var)
{
 		if(!sxs_var || !(sxs_var->handle)) {
			dError("Fnc : Erreur de lecture de variable"); return 0;
		}
 		return HeapDeref(sxs_var->handle);
}

 //------------ Cration d'une variable TiOS ------------//
SYM_ENTRY *vat_make(const char *ssc_var,unsigned short sui_siz)
{
 	SYM_ENTRY *sxs_var=NULL;
 	if(!ssc_var || (!(sxs_var=vat_open(ssc_var)) && !(sxs_var=DerefSym(SymAdd(vat_name(ssc_var)))))){
 		dError("Creation de variable impossible"); return 0;
 	}
 *(unsigned short*)HeapDeref(sxs_var->handle=HeapRealloc(sxs_var->handle,sui_siz))=sui_siz-2;
 return sxs_var;
}

 //--------- Convertion d'un nom au format TiOS ---------//
char *vat_name(const char *ssc_var)
{
 memset(tuc_nam,0,19);
 return strcpy(tuc_nam+1,ssc_var)+strlen(ssc_var);
}

 //------ Obtention d'un pointeur vers un fichier -------//
SYM_ENTRY *vat_open(const char *ssc_var)
{
 return SymFindPtr(vat_name(ssc_var),0);
}


// fonction perso ... merci Bob !
void GerePicture(const char *nom, unsigned short taille, const SCR_RECT *rect){
	char *ma_var = NULL;
  strcpy(global_nom,nom); // on recupere le nom de l'image !
  if ((ma_var = vat_heap(vat_make(nom,taille))) != NULL)
  {
     BitmapGet(rect, ma_var+2);
     (ma_var)[taille-1] = PIC_TAG;
  }	  
}
