void InputPrettyPrint_as_Str (short x, short y, unsigned char *buffer, short maxlen);
short inputstr (short x, short y, unsigned char *buffer, short maxlen);
unsigned short GetKb(void);

short inputstr (short x, short y, unsigned char *buffer, short maxlen)
// retourne la taille de la chaine de caractre
{
  SCR_STATE ss;
  short key = 0;
  short i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf_xy(x,y,"%s   ", buffer);
      key = GetKb();
      if (key >= ' ' && key <= '~' && i < maxlen)
        buffer[i++] = key;
      else if (key == KEY_BACKSPACE && i)
        i--;
      buffer[i] = 0;
    } while (key != KEY_ENTER);   
    return i;
}

#define XXX 6
const char *Caracteres[XXX] = {
	"0: \xBE", //infini (190 vs. 276 en octal vs. BE en hexa)
	"1: \x97", //i complexe 151
	"2: \x96", // e
	"3: \xA8", // sqrt
	"4: \xAD", // (-) sign = 173 
	"5: \x27"  // prime (39)
};



void InputPrettyPrint_as_Str (short x, short y, unsigned char *buffer, short maxlen)
{
	SCR_STATE ss;
  short key=0, i=0, captured;
	
  void CaptureHandler (EVENT *ev)
    {
      if (ev->Type == CM_STRING){
        captured = *(ev->extra.pasteText);
       }
    }

  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf_xy (x,y,"%s_  ", buffer);
      key = GetKb();

      if (key == KEY_ESC) return;
      
      if (	 ((key == KEY_CHAR) && (i < maxlen)) 
      		|| ((key == KEY_MATH) && (i < maxlen))   
      	 )
        {
          EVENT ev;
          ev.Type = CM_KEYPRESS;
          ev.extra.Key.Code = key;
          EV_captureEvents ((EVENT_HANDLER)CaptureHandler);
          EV_defaultHandler (&ev);
          EV_captureEvents (NULL);
          buffer[i++] = captured;
          ev.Type = CM_UNFOCUS;
  				EV_sendEvent (AP_CURRENT, &ev);    
  				key = 0;
        }

      else if (key >= ' ' && key <= '~' && i < maxlen) buffer[i++] = key;
      else if (key == KEY_BACKSPACE && i) i--;

			else if (key == KEY_F5)
			{
	  		
	  		SaveBeforeAction();

	  		short kb_choice = 0;
	  		DrawRect(xmax-2-65,30,xmax-2,30+32);
	  		DrawClose(xmax-3,30);
#ifdef __LANGAGE_FR__ // ou comment faire une exemple !
				DrawStr(xmax-62,34,"Choix de carctr.",A_NORMAL);
#else
				DrawStr(xmax-62,34,"Chars choice",A_NORMAL); 
#endif
				DrawLine(xmax-2-65,41,xmax-2,41,A_NORMAL);
				DrawLine(xmax-2-65,43,xmax-2,43,A_NORMAL);
				UseGoodFont();
		
				DrawStr(xmax-65,45,Caracteres[0],A_NORMAL);
				DrawStr(xmax-45,45,Caracteres[1],A_NORMAL);
				DrawStr(xmax-25,45,Caracteres[2],A_NORMAL);
				DrawStr(xmax-65,55,Caracteres[3],A_NORMAL);
				DrawStr(xmax-45,55,Caracteres[4],A_NORMAL);
				DrawStr(xmax-25,55,Caracteres[5],A_NORMAL);

				while(1){

						while(!(kb_choice = ngetchx())) idle();
	
						if 			(kb_choice == KEY_ESC) break;
	
						if 			(kb_choice == 48) {buffer[i++] = '\xBE'; break;}
						else if	(kb_choice == 49) {buffer[i++] = '\x97'; break;}
						else if	(kb_choice == 50) {buffer[i++] = '\x96'; break;}
						else if	(kb_choice == 51) {buffer[i++] = '\xA8'; break;}
						else if	(kb_choice == 52) {buffer[i++] = '\xAD'; break;}
						else if	(kb_choice == 53) {buffer[i++] = '\x27'; break;}

								}

					RestoreByAnnul();					
			}
			
      buffer[i] = 0;

    } while (key != KEY_ENTER);

}



unsigned short GetKb(void) 
{
    void *kbq = kbd_queue();
    unsigned short  key=0;
    while (OSdequeue(&key, kbq))
      idle();
    return key & ~(unsigned short)0x800;
}