
short CStrToAMSStr(const char *Str, const char *VarName);
SYM_ENTRY* SelectMenu(void);
void SavePic(short x1, short y1, short x2, short y2, const char *rep, const char *name);


short menuopt= 0;
short CStrToAMSStr(const char *Str, const char *VarName) 
{
	HANDLE Handle;
	HSym HSymVar;
	SYM_ENTRY *pSymEntry;
	unsigned long StrLen = strlen(Str);
	unsigned char *pFile;
	unsigned short i;

  if (!(Handle = HeapAlloc(StrLen + 5))) return FALSE;
  HSymVar = SymAdd(SYMSTR(VarName));
  if (HSymVar.folder == H_NULL) {
    HeapFree(Handle);
    return FALSE;
  }

  if ((pSymEntry = DerefSym(HSymVar)) == NULL) {
    HeapFree(Handle);
    return FALSE;
  }

  pSymEntry->handle = Handle;

  pFile = (unsigned char *)HeapDeref(pSymEntry->handle);

  if (StrLen + 3 <= 0xFF) {
	*pFile++ = 0;
	*pFile++ = StrLen + 3;
  }
  else {
	*pFile++ = (StrLen + 3) / 0xFF;
	*pFile++ = (StrLen + 3) % 0xFF - 1;
  }

  *pFile++ = 0;

  for (i=0;i<StrLen;i++) {
    *pFile++ = Str[i];
  }

  *pFile++ = 0;
  *pFile++ = STR_TAG;

  return TRUE;
}


// Slction de l'image  ouvrir, pour l'instant,
// ca n'ouvre que les image non zippes ..
SYM_ENTRY* SelectMenu(void) 
{
    short          i,select,index=1,ng=0;
    HANDLE         shandle,mhandle = 0;
    SYM_ENTRY*     symptr=SymFindFirst(NULL,2);
    
    FontSetSys(F_4x6);
#ifdef __LANGAGE_FR__    
    mhandle=PopupNew("Selection de l'image",_C_(53,69)); 
#else
    mhandle=PopupNew("Select the picture",_C_(53,69)); 
#endif
    while (symptr)
    {
        shandle = symptr->handle;
        
        if (shandle) 
        {
                if (peek(HToESI(shandle)) == PIC_TAG) 
                {
                    PopupAddText(mhandle,-1,symptr->name,index);
                    if (!menuopt) menuopt=index;
                    ng++;
                }
            index++;
        }
        symptr=SymFindNext();
    }
		ngetchx();

    if(ng) select=PopupDo(mhandle,CENTER,(ng>4)?_C_(20,30):(_C_(40,50)-4*ng),menuopt);
    else 
    {
#ifdef __LANGAGE_FR__
				DrawStatus_OO("Pas d'image, appuyez sur [ESC]...");
#else
				DrawStatus_OO("No picture, kick [ESC]...");
#endif			
        select=0;
        wait();
    }

    HeapFree(mhandle);
    if(!select) return NULL;
    menuopt=select;
    symptr=SymFindFirst(NULL,2);
    for(i=1;i<select;i++) symptr=SymFindNext();
    return symptr;
}


#include "Creation_VAT.h"

void SavePic(short x1, short y1, short x2, short y2, const char *rep, const char *name)
{
	char NOM[18] = ""; 
	short x_ = min(x1,x2); x2 = max(x1,x2);
	short y_ = min(y1,y2); y2 = max(y1,y2);
	x1 = x_; y1 = y_;
	// PIC = 0,0,BITMAP,PIC_TAG
	unsigned short j = BitmapSize(&(SCR_RECT){{x1-1, y1-1, x2+1, y2+1}}) + 3;
	strcat(NOM,rep); strcat(NOM,"\\"); strcat(NOM,name); 
  GerePicture(NOM,j,&(SCR_RECT){{x1-1, y1-1, x2+1, y2+1}});
}
