
#define RETURN_VALUE

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS
#define USE_V200              // Compile for V200

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define MIN_AMS 200           // Compile for AMS 2.00 or higher
#define SAVE_SCREEN           // Save/Restore LCD Contents

#define __NOSTUB__

#include <tigcclib.h>

unsigned char *dessin = NULL, *lcd_sav = NULL;//sauvegarde pour annuler les action
short ymax, xmax;
char global_nom[19] = "";


#define __mVERSION__			"1.01a"

#define wait() 					{while(!_keytest(RR_ESC)) idle();}
#define Idle() 					{short TIME = 5000; while(TIME--) idle();}
#define dError(a)  			DlgMessage((const char *)"Erreur",(const char *)a,BT_NONE,BT_OK)
#define Free(a)		 			{if(a) free(a);}	
#define Swap(a,b)				{a^=b; b^=a; a^=b;}


#define _C_(a,b) 	Is89(a,b)
#define Is89(a,b)	(CALCULATOR ? b : a)

// gestion du langage

//#define __LANGAGE_FR__

#ifdef __LANGAGE_FR__
#define _LANGAGE_FR_ 1
#else
#define __LANGAGE_EN__
#define _LANGAGE_FR_ 0
#endif


#include "langage.h"
#include "sprite.h"
#include "interface.h"


void _main(void)
{
	xmax = _C_(160,240);
	ymax = _C_(100,128);

	// allocation des ecrans virtuels de sauvegardes ...
	if (((dessin = malloc(LCD_SIZE)) == NULL) || ((lcd_sav = malloc(LCD_SIZE)) == NULL)){
		dError(less_ram);
		return;
	}

	
	ClrScr();
	OSSetSR (0x0700); // on dsactive la barre status (alpha ...)

	
	LoadInterface();
	BoucleMenu();

	
	OSSetSR (0x0000); // on active la barre status (alpha ...)
	Free(dessin);  Free(lcd_sav);
  ST_showHelp(version);
  EVENT  ev;
	char retour[19+4] = ""; // stockage pour le coller ...
	sprintf(retour,"&P %s",global_nom);
	CB_replaceTEXT(retour, strlen(retour), 0);
  ev.Type = CM_MENU_PASTE;  
  push_zstr("r_gaucher@hotmail.com"); // RETURN_VALUE est mis donc .. ca marche !
}
